{% extends 'dashboard/dashboard_content.html' %}

{% block head_block %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/js/select2.min.js"></script>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/css/bootstrap-select.min.css">

    <!-- Latest compiled and minified JavaScript -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.11.2/js/bootstrap-select.min.js"></script>

{% endblock %}

{% block rightPane %}
    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-archive"></i>
                Add Batch
            </h2>
            <ul class="nav navbar-right panel_toolbox">
                <li><a class="save btn btn-sm btn-info"
                       href="{% url 'view_split_batches' semester_pk=selected_semester %}" style="color: #5b06b5">Delete
                    Batches</a>
                </li>
            </ul>
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <div class="row">
                <ul class="nav nav-tabs bar_tabs">
                    {% for semester in list_of_semesters %}
                        {% if forloop.counter == 1 %}
                            <li {% if selected_semester == semester.semester_instance.pk %}class="active" {% else %}
                                class="" {% endif %}>
                                <a aria-expanded="true"
                                   id={{ semester.semester_instance.pk }}
                                           data-toggle="tab" name="batch_tab">
                                    {{ semester.display_text }}

                                </a>
                            </li>
                        {% else %}
                            <li {% if selected_semester == semester.semester_instance.pk %}class="active" {% else %}
                                class="" {% endif %}>
                                <a aria-expanded="true"
                                   id={{ semester.semester_instance.pk }}
                                           data-toggle="tab" name="batch_tab">
                                    {{ semester.display_text }}
                                </a>
                            </li>
                        {% endif %}
                    {% endfor %}
                </ul>
                <div class="col-md-12 col-sm-12 col-xs-12">
                    <div class="form-horizontal form-label-left">
                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Select Lab
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select id="select_lab" class="form-control" required>
                                    <option value="" selected>Select a Practical Course</option>
                                    {% for course in list_of_practical_courses %}
                                        <option value="{{ course.pk }}">{{ course }}</option>
                                    {% endfor %}
                                </select>
                            </div>
                        </div>

                        <div class="form-group" id="start_student">
                            <label class="col-md-3 col-sm-3 col-xs-12 control-label">Start Student Roll Number</label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select id="id_start_student" name="start_student" required class="form-control">
                                </select>
                            </div>
                        </div>


                        <div class="form-group" id="end_student">
                            <label class="col-md-3 col-sm-3 col-xs-12 control-label">End Student Roll Number</label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select id="id_end_student" name="end_student" required class="form-control">
                                </select>
                            </div>
                        </div>


                        <div class="form-group" id="day">
                            <label class="col-md-3 col-sm-3 col-xs-12 control-label">Day</label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <select id="id_day" name="end_student" required class="form-control">
                                </select>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                                Batch Number
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <input class="form-control" placeholder="Batch Number" type="number"
                                       id="batch_number" required>
                            </div>
                        </div>

                        <div class="form-group">
                            <label class="control-label col-md-3 col-sm-3 col-xs-12">
                            </label>
                            <div class="col-md-6 col-sm-6 col-xs-12">
                                <button id="add" type="submit" class="btn btn-success">Add Practical Batch</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div>
                <table class="table table-hover table-striped " style="table-layout:fixed">
                    <thead>
                    <tr>
                        <th style="word-wrap: break-word">S. No.</th>
                        <th style="word-wrap: break-word">Batch Number</th>
                        <th style="word-wrap: break-word">Course</th>
                        <th style="word-wrap: break-word">Start Roll Number</th>
                        <th style="word-wrap: break-word">End Roll Number</th>
                        <th style="word-wrap: break-word">Day</th>
                    </tr>
                    </thead>
                    <tbody id="content">
                    {% for lab_batch in list_of_lab_batches %}
                        <tr>
                            <td style="word-wrap: break-word">{{ forloop.counter }}</td>
                            <td style="word-wrap: break-word">{{ lab_batch.batch_number }}</td>
                            <td style="word-wrap: break-word">{{ lab_batch.course }}</td>
                            <td style="word-wrap: break-word">{{ lab_batch.start_student.roll_no }}</td>
                            <td style="word-wrap: break-word">{{ lab_batch.end_student.roll_no }}</td>
                            <td style="word-wrap: break-word">{{ lab_batch.day.day_name }}</td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
        <br>
        <br>
        <br>
        <br>
    </div>

    <form id="dummy_form" method="POST">
        {% csrf_token %}
    </form>


    <script type="text/javascript">


        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $('document').ready(function () {
            $('[name="batch_tab"]').click(function () {
                //curent_subject = this.id;
                {#                alert(this.id);#}

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'selected_semester'});
                $hiddenInput.appendTo('form');


                $('#dummy_form').submit();

            });
        });

        $(function () {
            $("#datepick").datepicker();
        });

        function isNumberKey(evt) {
            var charCode = (evt.which) ? evt.which : evt.keyCode;
            if (charCode != 46 && charCode > 31
                && (charCode < 48 || charCode > 57))
                return false;

            return true;
        }


        var current_active_batch;
        $(document).on("change", '#select_lab', function (e) {
            if ($(this).val() == "") {
                return;
            }
            $.ajax({
                type: "POST",
                data: {
                    fetch_students: true,
                    selected_semester_pk: {{ selected_semester }},
                    selected_course_pk: $(this).val(),
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'add_lab_batch' %}',
                success: function (data) {
                    var myNode = document.getElementById("id_start_student");
                    while (myNode.firstChild) {
                        myNode.removeChild(myNode.firstChild);
                    }
                    list_of_students = data['list_of_students'];
                    console.log(list_of_students);
                    $("#id_start_student").append('<option value="" selected="selected">Select start roll number</option>');
                    for (var i = 0, l = list_of_students.length; i < l; i++) {
                        $("#id_start_student").append('<option value="' + list_of_students[i] + '">' + list_of_students[i] + '</option>');
                    }

                    var myNode = document.getElementById("id_end_student");
                    while (myNode.firstChild) {
                        myNode.removeChild(myNode.firstChild);
                    }
                    list_of_students = data['list_of_students'];
                    console.log(list_of_students);
                    $("#id_end_student").append('<option value="" selected="selected">Select end roll number</option>');
                    for (var i = 0, l = list_of_students.length; i < l; i++) {
                        $("#id_end_student").append('<option value="' + list_of_students[i] + '">' + list_of_students[i] + '</option>');
                    }

                    var myNode = document.getElementById("id_day");
                    while (myNode.firstChild) {
                        myNode.removeChild(myNode.firstChild);
                    }
                    list_of_day_instances = data['list_of_day_instances'];
                    console.log(list_of_day_instances);
                    $("#id_day").append('<option value="" selected="selected">Select Day</option>');
                    for (var i = 0, l = list_of_day_instances.length; i < l; i++) {
                        $("#id_day").append('<option value="' + list_of_day_instances[i] + '">' + list_of_day_instances[i] + '</option>');
                    }

                }
            });
        });

        $(document).on("click", '#add', function (e) {

            var course_pk = $('#select_lab').val();
            var start_student = $('#id_start_student').val();
            var end_student = $('#id_end_student').val();
            var day = $('#id_day').val();
            var batch_number = $('#batch_number').val();

            //alert(course_pk);

            if (course_pk.length == 0 ||
                start_student.length == 0 ||
                end_student.length == 0 ||
                day.length == 0 ||
                batch_number.length == 0) {
                alert('Enter proper details');
                return;
            }

            $.ajax({
                type: "POST",
                data: {
                    selected_semester_pk: {{ selected_semester }},
                    course_pk: course_pk,
                    start_student: start_student,
                    end_student: end_student,
                    day: day,
                    batch_number: batch_number,
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'add_lab_batch' %}',
                success: function (data) {
                    if (data['modal']) {
                        alert(data['modal']['body']);
                        return;
                    }
                    //alert('done');
                    $('#id_courses').val("");
                    $('#id_start_student').val("");
                    $('#id_end_student').val("");
                    $('#id_day').val("");
                    $('#batch_number').val("");
                    document.getElementById('content').innerHTML = "";

                    var counter = 1;

                    $.each(data.list, function (key, val) {
                        document.getElementById('content').innerHTML += '<tr><td style=\"word-wrap: break-word\"><br>' + counter++ + '</td><td style=\"word-wrap: break-word\">' +
                            val.batch_number + '</td><td style=\"word-wrap: break-word\">' +
                            val.course + '</td><td style=\"word-wrap: break-word\">' +
                            val.start_student + '</td><td style=\"word-wrap: break-word\">' +
                            val.end_student + '</td><td style=\"word-wrap: break-word\">' +
                            val.day + '</td></tr>';
                    })

                }
            });
        });
    </script>

{% endblock %}